var wright = wright || {};

var wright = {
    design: function (data, node) {
        if (data == undefined) {
            return;
        }
        /* Assign type, otherwise assume div */
        if (data.type != null) {
            type = data.type;
        } else {
            type = "div"
        }
        /* Create node */
        if (node == undefined) {
            var node = document.createElement(type);
        }
        /* Add element attributes */
        if (data.attribs != null && data.attribs != "") {
            for (var key in data.attribs) {
                if (data.attribs.hasOwnProperty(key)) {
                    if (key == "class") {
                        if (data.attribs[key] instanceof Array) {
                            for (var i = 0; i < data.attribs[key].length; i++) {
                                node.classList.add (data.attribs[key][i]);
                            }
                        } else {
                            node.classList.add (data.attribs[key]);
                        }
                    } else if (key == "dataset") {
                        for (var subkey in data.attribs[key]) {
                            if (data.attribs[key].hasOwnProperty(subkey)) {
                                node.dataset[subkey] = data.attribs[key][subkey];
                            }
                        }
                    } else {
                        node[key] = data.attribs[key];
                    }
                }
            }
        }
        /* Fill in content */
        if (typeof data.content == "object") {
            if (data.content instanceof Array) {
                for (var i = 0; i < data.content.length; i++) {
                    node.appendChild (this.design (data.content[i]));
                }
            } else {
                node.appendChild (this.design (data.content));
            }
        } else {
            node.innerHTML = data.content;
        }
        
        return node;
    },
    
    append: function (selector, data) {
        var element = document.querySelector (selector);
        element.appendChild (data);
    },
    
    update: function (selector, data) {
        var element = document.querySelectorAll (selector);
        for (var i = 0; i < element.length; i++) {
            //element[i].innerHTML = data.content;
            this.design (data, element[i]);
        }
    },
    
    remove: function (selector, selector2) {
        var element = document.querySelector (selector),
            element2 = document.querySelector (selector2);
        element.removeChild (element2);
    },
    
    removeAll: function (selector, selector2) {
        var element = document.querySelector (selector),
            element2 = document.querySelectorAll (selector2);
        for (var i = 0; i < element2.length; i++) {
            element.removeChild (element2[i]);
        }
    },
    
    empty: function (selector) {
        var element = document.querySelector (selector);
        element.innerHTML = "";
    }
}
